# -------------------------------------------------------------------------------------
# flo::plugin::DC
# -------------------------------------------------------------------------------------
# Author : Jean-Michel Hiver.
# Copyright : (c) MKDoc Holdings Ltd, 2003.
#
# This file is part of MKDoc. 
# 
# MKDoc is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# MKDoc is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with MKDoc; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
# This plugin outputs RDF dublin core metadata for the current document
# -------------------------------------------------------------------------------------
package flo::plugin::DC;
use flo::Standard;
use strict;
use base qw /flo::Plugin/;

sub _name_default { '.meta.rdf' }

sub run
{
    my $self = shift;
    $self->render_http (
	self       => $self,
	object     => flo::Standard::current_document,
	__input__  => 'XML',
	__output__ => 'XHTML',
       );
    
    return 'TERMINATE';
}

sub content_type  { 'application/xml'       }

sub template_path { '/metadata/dcq.rdf.xml' }


1;


__END__
