# -------------------------------------------------------------------------------------
# lib::util::Command
# -------------------------------------------------------------------------------------
#
#       Author : Jean-Michel Hiver.
#    Copyright : (c) MKDoc Holdings Ltd., 2001.
#
# This file is part of MKDoc. 
# 
# MKDoc is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# MKDoc is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with MKDoc; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
#    Description:
#
#      A horrible hack that allows to execute unix commands, pass them some
#      input, and grab the output and error data. Well, at least it's less
#      hassle to use compared with IPC::Open3
#
# -------------------------------------------------------------------------------------
package lib::util::Command;
use strict;
use warnings;
use Exporter;
use Carp;
use bytes;
no utf8;

use vars qw /@ISA @EXPORT/;
@ISA = qw/Exporter/;
@EXPORT = qw /sysexec/;


sub sysexec($$$)
{
    my $cmd = shift;
    my $tmp_dir = shift;
    my $in  = shift;
    Encode::_utf8_off ($in);
    
    my $out = undef;
    my $err = undef;
    
    my $tmp = $$ . '.' . time . '.' . int (rand (10000));
    my $tmp_out = $tmp_dir . '/' . $tmp . '.out';
    my $tmp_err = $tmp_dir . '/' . $tmp . '.err';
    
    if (defined $in)
    {
	# executes the command and writes to temp files
	open FP, "|$cmd 2>$tmp_err >$tmp_out" or
            die "Cannot open pipe to $cmd: $!";
	print FP $in;
	close FP;
    }
    else
    {
	# executes the command and writes to temp files
	system ("$cmd 2>$tmp_err >$tmp_out") or
	    die "Cannot exec $cmd: $!";
	print FP $in;
	close FP;
    }
    
    # reads the command standard output
    open (FP, $tmp_out) or
	die "Cannot read-open file $tmp_out: $!";
    $out = join '', <FP>;
    close FP;
    
    # reads the command error output
    open FP, "<$tmp_err" or
        die "Cannot read-epen file $tmp_err: $!";
    $err = join '', <FP>;
    close FP;
    
    # tidy all the mess and returns $out and $err
    unlink $tmp_out;
    unlink $tmp_err;
    return ($out, $err);
}


1;
